; 
;   Copyright 1994-2003 Free Software Foundation, Inc.
;
;   This library is free software; you can redistribute it and/or
;   modify it under the terms of the GNU Lesser General Public
;   License as published by the Free Software Foundation; either
;   version 2.1 of the License, or (at your option) any later version.
;
;   This library is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;   Lesser General Public License for more details.
;
;   You should have received a copy of the GNU Lesser General Public
;   License along with this library; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
;   USA
;
;   You may contact the author at:
;
;   mailto::camille@bluegrass.net
;
;   or by snail mail at:
;
;   David Lindauer
;   850 Washburn Ave Apt 99
;   Louisville, KY 40222
;
;
; Copyright (c) 2000 LADsoft
;
; David Lindauer, camille@bluegrass.net
;
.386p
locals
	     	.model small

_TEXT		segment USE32 'CODE'
_TEXT		ends
_STRING		segment USE32 DWORD PUBLIC 'STRING'
_STRING		ends
_CONST		segment USE32 DWORD PUBLIC 'CONST'
_CONST		ends
_DATA   	segment USE32 'DATA'
                db      "Copyright (c) 1997-2003 LADsoft C runtime library"
		db	" (i386/WIN32)"
                ENDS
cstartup        segment USE32 DWORD PUBLIC 'INITDATA'
		dd	0
InitStart       label dword
                ENDS
_STARTUPEND_       segment USE32 DWORD PUBLIC 'INITDATA'
InitEnd         label dword
		dd	0
                ENDS
crundown        segment USE32 DWORD PUBLIC 'EXITDATA'
		dd	0
ExitStart       label dword
                ENDS
_RUNDOWNEND_       segment USE32 DWORD PUBLIC 'EXITDATA'
ExitEnd         label dword
		dd	0
                ENDS
cppinit         SEGMENT DWORD PUBLIC USE32 'CPPINIT'
CppStart        label dword
		dd	cpproutine,130
                ENDS
_CPPEND_        SEGMENT DWORD PUBLIC USE32 'CPPINIT'
CppEnd          label dword
		dd	0
		ENDS
cppexit         SEGMENT DWORD PUBLIC USE32 'CPPEXIT'
CpprStart        label dword
		dd	cpproutine,130
                ENDS
_CPPREND_        SEGMENT DWORD PUBLIC USE32 'CPPEXIT'
CpprEnd          label dword
		dd	0
		ENDS
_BSS	        segment USE32 'BSS'
		dd	0004E4957h
BssStart	label dword
                ENDS
_BSSEND	        segment USE32 'BSS'
BssEnd		label dword
		dd	00044414ch
                ENDS

DGROUP group _DATA,cstartup,_STARTUPEND_,crundown,_RUNDOWNEND_,cppinit,_CPPEND_,_BSS,_BSSEND

assume cs:_TEXT,ds:DGROUP,es:DGROUP,fs:nothing,gs:nothing,ss:nothing

;

_DATA   	SEGMENT
	align 4
		public __oscmd, __osenv,__hinstance
__oscmd		dd	0
__osenv		dd	0
__hinstance	dd	0
ifdef		CONSOLE
__win32		dd	0
else
__win32		dd	1
endif
ifdef 		DLL
xcptsv1		dd	0
xcptsv2		dd	0
dllexists	dd	0
nError		db	"Error",0
nNonSharedDataSeg db	"NonShared data segment required",0
endif

                ENDS
_TEXT		SEGMENT
;
; C startup procedures
;
start:
ifndef DLL
                push    0               ; so the debugger can find the TOS
endif
		push	ebp
		mov	ebp,esp
		sub	esp,8
		push	esi
		push	edi
		push	ebx

ifdef		DLL
		cmp	dword ptr [ebp+12],1
		jnz	ndll1
		cmp	[dllexists],0
		jz	cdll1
		push	0
		push	offset nError
		push	offset nNonSharedDataSeg
		push	0
		extrn	MessageBoxA: PROC
		call	MessageBoxA
		sub	eax,eax
		jmp	dllfin
cdll1:
		inc 	[dllexists]		
				

ndll1:
endif

		extrn GetEnvironmentStrings : PROC
		call  GetEnvironmentStrings
		mov   __osenv,eax

ifndef DLL
		extrn GetCommandLineA : PROC
		call  GetCommandLineA
		mov   __oscmd,eax
endif

		extrn GetModuleHandleA : PROC
		push	0
		call  GetModuleHandleA
		mov   __hinstance, eax

ifdef DLL
		cmp	dword ptr [ebp+12],1
		jnz	ndll2

		mov	edx,fs:[4]
		mov	eax,[edx-4]
		mov	[xcptsv1],eax
		mov	eax,[edx-8]
		mov	[xcptsv2],eax
else
		extrn  __llfpinit :  PROC
		call   __llfpinit
endif
		
		extrn	__xceptinit : PROC
		lea	eax,[ebp-8] ; We put this on the stack in case the data seg gets wiped...
		push	eax
		call	__xceptinit

;
; Execute startup routines
;
		mov	ecx,offset InitStart
		mov	edx,offset InitEnd
		call	sexproc
		cld
;
; Execute C++ class initializers
;
		mov	ecx,offset CppStart
		mov	edx,offset CppEnd
		call	sexproc
		cld
ifdef DLL
ndll2:
endif
;
; Call main
;
ifdef		CONSOLE
                extrn   __argv:DWORD,__argc:DWORD,__environ:DWORD
		push	__environ
                push    __argv
		push	__argc
ifdef DEBUG
		extrn monitor_init:proc
		call monitor_init
endif
		extrn	_main : PROC
		call	_main
		add	esp,12
else
ifdef 		DLL
                push    dword ptr [ebp+16]
		push	dword ptr [ebp+12]
                push    dword ptr [ebp+8]
		extrn	DllEntryPoint : PROC
		call	DllEntryPoint
else
; Bypass command name
		mov	esi,__oscmd
wlp1:
		lodsb
                or      al,al
                jz      wend
 		cmp	al,' '
		jz	wlp1
		cmp	al,9
		jz 	wlp1
		mov	dl,' '
		cmp	al,'"'
		jnz	wlp2
		inc	esi
		mov	dl,al
wlp2:
		lodsb
                or      al,al
                jz      wend
		cmp	al,dl
		jz	wx1
		or	al,al
		jnz	wlp2

wx1:
		cmp	al,'"'
		jnz	wx2
		inc	esi
wx2:	
		lodsb
                or      al,al
                jz      wend
		cmp	al,' '
		jz	wx2
		cmp	al,9
		jz	wx2
wend:
		dec	esi

		push    10
		push	esi
		push	0
		push	__hinstance

		extrn	WinMain : PROC
		call	WinMain
		
endif
endif
; exit/abort comes here
;
                public  __rexit, __rexita
__rexit:
ifndef		DLL
		push	eax		; saving C return code
;
; Execute C++ class rundown routines
;
		cld
		mov	ecx,offset DGROUP:CpprStart
		mov	edx,offset DGROUP:CpprEnd
		call	sexproc
;
; Execute rundown routines
;
		mov	ecx,offset ExitStart
		mov	edx,offset ExitEnd
		call	sexproc
                pop     eax
__rexita:
                push    eax
		extrn	__xceptrundown : PROC
		call	__xceptrundown

		extrn   ExitProcess : PROC
		call	ExitProcess ; return code already on stack
; probably don't get here, but be safe...
                pop     eax
else
__rexita:
		cmp	dword ptr [ebp+12],1
                jnz     dllfin
		mov	edx,fs:[4]
                mov     ecx,[xcptsv1]
                mov     [edx-4],ecx
                mov     ecx,[xcptsv2]
                mov     [edx-8],ecx
dllfin:
endif
		pop	ebx
		pop	edi
		pop	esi
		mov	esp,ebp
		pop	ebp
ifdef DLL
		ret	12
else
                pop     eax     ; pop the 0
		ret
endif
;
; Handle startup/rundown routines
;
sexproc:
		cmp	ecx,edx		
		jz	short sexpdone	
		mov	edi,ecx
		sub	ebx,ebx
		sub	eax,eax
spl2:
		cmp	edi,edx
		jz	short spo
		test	dword ptr [edi+4],-1
		jz	short spl3
		cmp	eax,[edi+4]
		jnc	short spl3
		mov	ebx,edi
		mov	eax,[edi+4]
spl3:
		add	edi,8
		jmp	spl2
spo:
		or	ebx,ebx
		jz	short sexpdone
		mov	dword ptr [ebx+4],0
		push	edx
		push	ecx
		call	[ebx]
		pop	ecx
		pop	edx
		jmp	sexproc
sexpdone:
		ret

; This is called as the first thing from the C++ main routine
cpproutine:
		ret
;
; Put a message out on the console
;
_TEXT		ends
end     start